stages:
  - prepare
  - bump
  - build
  - release
  - pages

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == "master"

variables:
  TYPE: utils
  KIND: converter
  NAME: md2pdf

set_env:
  stage: prepare
  image:
    name: python:3.8-slim
    entrypoint: [""]
  script:
    - echo "IMAGE_NAME=$CI_REGISTRY/${TYPE}/${KIND}/${NAME}" >> workflow.env

    - CI_BUMP_TYPE=`echo ${CI_COMMIT_MESSAGE} | awk -F"[][]" '{print $2}'`
    - echo "CI_BUMPVERSION=${CI_BUMP_TYPE}" >> workflow.env
  artifacts:
    reports:
      dotenv: workflow.env

bumpversion:
  stage: bump
  image:
    name: registry.gitlab.com/bswrundquist/utils/versioning/bump
    entrypoint: [""]
  script:
    - bump --type [lhs|middle|rhs|promote|release] --version v0.1.0-ALPHA1
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: never # Change...
    - when: never

srs:
  stage: release
  image:
    name: registry.gitlab.com/bswrundquist/utils/converters/md2pdf
    entrypoint: [""]
  script:
    - md2pdf Software_Requirements_Specifications.md --to Software_Requirements_Specifications.pdf
  artifacts:
    paths:
    - Software_Requirements_Specifications.pdf
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: never # Change...
    - when: never

build_docker:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor@sha256:5a6b3193506212ea7703214bf3b21cd898e5e2ec14d6b988cc9d11a9b34f32d4
    entrypoint: [""]
  script:
    - BUMPED_VERSION=v0.1.0-ALPHA.0
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor
      --context $CI_PROJECT_DIR
      --dockerfile $CI_PROJECT_DIR/Dockerfile
      --destination $CI_REGISTRY_IMAGE:$BUMPED_VERSION
      --destination $CI_REGISTRY_IMAGE:latest
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: always
    - if: $CI_ACTION == "build"
      when: always
    - when: never

release_job:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  script:
    - echo 'running release_job'
  release:
    name: 'Release $BUMPED_VERSION'
    description: '$CI_COMMIT_MESSAGE'
    tag_name: 'release-$CI_COMMIT_SHA'
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: always
    - when: never

pages:
  stage: pages
  image:
    name: registry.gitlab.com/bswrundquist/docs/static-site/mkdocs
  script:
  - mkdocs build
  - mv site public
  artifacts:
    paths:
    - public
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: always
    - changes:
        - docs/
      when: always
    - when: never

